program arma;
{$G+,N+}

const
  n=1024;
  m1=3;
  m2=2;
  l=100;

var
  X:array[1..n] of double;
  R:array[1..n] of double;
  A:array[1..m1] of double;
  B:array[1..m2] of double;
  C:array[0..l] of double;

function prenoise:double;
var
  p:double;
begin
  p:=random(65535);
  prenoise:=p/65535.0;
end;

function noise:double;
var
  i:integer;
  p:double;
begin
  p:=0.0;
  for i:=1 to 12 do
  begin
    p:=p+prenoise;
  end;
  noise:=p-6.0;
end;

procedure init;
var
  i:integer;
begin
  randomize;
  for i:=1 to n do
  begin
    R[i]:=noise;
  end;
  A[1]:=-0.6;
  A[2]:=0.51;
  A[3]:=0.378;
  B[1]:=0.8;
  B[2]:=0.15;
end;

procedure gener;
var
  i,j:integer;
  p,q:double;
begin
  for i:=3 to n do
  begin
    p:=0.0;
    q:=R[i];
    for j:=1 to m1 do
    begin
      if ((i-j)>=1) then
      begin
        p:=p+A[j]*X[i-j];
      end;
    end;
    for j:=1 to m2 do
    begin
      if ((i-j)>=1) then
      begin
        q:=q+B[j]*R[i-j];
      end;
    end;
    X[i]:=p+q;
  end;
end;

procedure autocorr;
var
  i,j:integer;
  p,q:double;
begin
  p:=0.0;
  for i:=1 to n do
  begin
    p:=p+X[i];
  end;
  p:=p/n;
  for j:=0 to l do
  begin
    q:=0.0;
    for i:=1 to n-j do
    begin
      q:=q+(X[i]-p)*(X[i+j]-p);
    end;
    q:=q/(n-j);
    C[j]:=q;
  end;
end;

procedure done;
var
  f:text;
  i:integer;
begin
  assign(f,'arma.dat');
  rewrite(f);
  for i:=1 to n do
  begin
    writeln(f,i,' ',X[i]:0:4);
  end;
  close(f);

  assign(f,'noise.dat');
  rewrite(f);
  for i:=1 to n do
  begin
    writeln(f,i,' ',R[i]:0:4);
  end;
  close(f);

  assign(f,'acor.dat');
  rewrite(f);
  for i:=0 to l do
  begin
    writeln(f,i,' ',C[i]:0:4);
  end;
  close(f);

  assign(f,'armaspt1.inp');
  rewrite(f);
  writeln(f,0,' ',(1.0):0:4);
  for i:=1 to m1 do
  begin
    writeln(f,i,' ',A[i]:0:4)
  end;
  close(f);

  assign(f,'armaspt2.inp');
  rewrite(f);
  writeln(f,0,' ',(1.0):0:4);
  for i:=1 to m2 do
  begin
    writeln(f,i,' ',B[i]:0:4);
  end;
  close(f);

  assign(f,'armaspt3.inp');
  rewrite(f);
  for i:=1 to n do
  begin
    writeln(f,i,' ',X[i]:0:4);
  end;
  close(f);
end;

begin
  init;
  gener;
  autocorr;
  done;
end.
