program tacor;
{$G+,N+}

const
  NN=3000;
  LL=100;
  PP=3;
  QQ=2;

var
  n:integer;
  A:array[1..PP] of double;
  B:array[0..QQ] of double;
  C:array[0..LL] of double;
  G:array[0..PP,0..PP+1] of double;

function D(k:integer):double;
var
  i:integer;
  s:double;
begin
  if (k<0) then D:=0.0
  else if (k=0) then D:=B[0]
  else if ((k>=1) and (k<=QQ)) then
  begin
    s:=0.0;
    for i:=1 to PP do s:=s+A[i]*D(k-i);
    D:=s+B[k];
  end
  else if (k>QQ) then D:=0.0;
end;

procedure init;
var
  i,j:integer;
  s:double;
begin
  A[1]:=-0.6;
  A[2]:=0.51;
  A[3]:=0.378;
  B[0]:=1.0;
  B[1]:=0.8;
  B[2]:=0.15;
  for i:=0 to LL do C[i]:=0.0;
  for i:=0 to PP do for j:=0 to (PP+1) do G[i,j]:=0.0;
end;

procedure gauss;
var
  i,j,k,p,q:integer;
  r:array[0..PP] of integer;
  aa,bb,cc:double;
begin
  for i:=0 to PP do r[i]:=i;
  for j:=0 to (PP-1) do
  begin
    p:=j;
    q:=j;
    for i:=j to PP do
      for k:=j to PP do
        if (G[i,k]>G[p,q]) then
        begin
          p:=i;
          q:=k;
        end;
    for i:=0 to (PP+1) do
    begin
      cc:=G[j,i];
      G[j,i]:=G[p,i];
      G[p,i]:=cc;
    end;
    for i:=0 to PP do
    begin
      cc:=G[i,j];
      G[i,j]:=G[i,q];
      G[i,q]:=cc;
    end;
    k:=r[j];
    r[j]:=r[q];
    r[q]:=k;
    for i:=(j+1) to PP do
    begin
      aa:=G[i,j]/G[j,j];
      for k:=j to (PP+1) do G[i,k]:=G[i,k]-aa*G[j,k];
    end;
  end;
  for j:=PP downto 0 do
  begin
    aa:=G[j][PP+1];
    for k:=PP downto (j+1) do aa:=aa-G[j,k]*G[k,(PP+1)];
    G[j,(PP+1)]:=aa/G[j,j];
  end;
  for i:=0 to PP do G[r[i],0]:=G[i,(PP+1)];
end;

procedure solve;
var
  i,j,k:integer;
  sa,sb:double;
begin
  for k:=0 to PP do
  begin
    G[k,k]:=1.0;
    for i:=1 to PP do G[k,abs(k-i)]:=G[k,abs(k-i)]-A[i];
    sb:=0.0;
    for i:=0 to QQ do sb:=sb+B[i]*D(i-k);
    G[k,PP+1]:=sb;
  end;
  gauss;
  for k:=0 to PP do C[k]:=G[k,0];
  for k:=(PP+1) to LL do
  begin
    sa:=0.0;
    sb:=0.0;
    for i:=1 to PP do sa:=sa+A[i]*C[k-i];
    for i:=0 to QQ do sb:=sb+B[i]*D(i-k);
    C[k]:=sa+sb;
  end;
end;

procedure done;
var
  f:text;
  i:integer;
begin
  assign(f,'tacor.dat');
  rewrite(f);
  for i:=0 to LL do
  begin
    writeln(f,i,' ',C[i]:0:4);
  end;
  close(f);
end;

begin
  init;
  solve;
  done;
end.
